import unittest


class MyMeta(type):

    def __new__(cls, *args, **kwargs):
        print("元类中的__new__被调用")
        return super(MyMeta, cls).__new__(cls, *args, **kwargs)
    
    def __init__(self, *args, **kwargs):
        print("元类中的__init__被调用")
        return super(MyMeta, self).__init__(*args, **kwargs)
    
    def __call__(self, *args, **kwargs):
        print("元类中的__call__被调用")
        return super(MyMeta, self).__call__(*args, **kwargs)

class MyClass(metaclass=MyMeta):
    def __new__(cls, *args, **kwargs):
        print("主类中的__new__被调用")
        return super(MyClass, cls).__new__(cls, *args, **kwargs)
    
    def __init__(self, *args, **kwargs):
        print("主类中的__init__被调用")
        return super(MyClass, self).__init__(*args, **kwargs)
    
    def __call__(self, *args, **kwargs):
        print("主类中的__call__被调用")
        return super(MyClass, self).__call__(*args, **kwargs)

print("-------------------------\n创建具体的对象前\n----------------------------------")
# m = MyClass()

class TestAa(unittest.TestCase):
    def testAa(self):
        """
        Purpose: 
        """
        print(self.__class__)
        m = MyClass()
        pass