from ..models import CacheVersion,EnvVariable
_cacheversions=None

def init_cacheversion():
    """
    Purpose: 获取最新，为空则初始化
    """
    global _cacheversions
    qa = CacheVersion.objects.all()
    if not qa.exists():
        CacheVersion.objects.create(vername=CacheVersion.VerName.AdmMenu,version=1)
        CacheVersion.objects.create(vername=CacheVersion.VerName.EnvVar,version=1)
        CacheVersion.objects.create(vername=CacheVersion.VerName.Category,version=1)
        
    _cacheversions = {obj.vername:obj for obj in qa}
    return _cacheversions
def get_cacheversion():
    """
    Purpose: 直接返回，为空则抛出异常
    """
    global _cacheversions
    if _cacheversions is None:
        init_cacheversion()
    if _cacheversions is not None:
        return _cacheversions
    else:
        raise Exception("cacheversion is empty!")
    

 
 
    
class CacheEnvVariable(object):
    """docstring for ClassName."""
    def __init__(self):
        self._variables=None
        self._variables_version=0
    
    @property
    def variables(self):
        cacheversion = get_cacheversion()
        version_last=cacheversion[CacheVersion.VerName.EnvVar].version
        if version_last>self._variables_version or self._variables is None:
            self.update_data()
            self._variables_version=version_last
        return self._variables
    def update_data(self):
        """获取最新数据
        """
        qa=EnvVariable.objects.all()
        if not qa.exists():
            self.init_data()
        self._variables={obj.varname:obj for obj in qa}
    def init_data(self):
        """
        Purpose: 使用默认值初始化数据
        """
        EnvVariable.objects.create(varname=EnvVariable.VarName.SiteName,vartype=EnvVariable.VarType.Str,varvalue="站点名称")
        EnvVariable.objects.create(varname=EnvVariable.VarName.DomainName,vartype=EnvVariable.VarType.Str,varvalue="绑定域名")
        EnvVariable.objects.create(varname=EnvVariable.VarName.SeoTitle,vartype=EnvVariable.VarType.Str,varvalue="标题")
        EnvVariable.objects.create(varname=EnvVariable.VarName.SeoKewords,vartype=EnvVariable.VarType.Str,varvalue="关键字")
        EnvVariable.objects.create(varname=EnvVariable.VarName.SeoDescription,vartype=EnvVariable.VarType.Str,varvalue="描述")
        EnvVariable.objects.create(varname=EnvVariable.VarName.AdmPathPrefix,vartype=EnvVariable.VarType.Str,varvalue="/adm/")
        pass
        
    # end def

cache_envvar=CacheEnvVariable()