from .config import get_cacheversion
from ..models import CacheVersion,AdminMenu,AdminMenuItem


class CacheAdmMenu(object):
    """docstring for CacheMenu."""
    def __init__(self):
        self._menus=None
        self._sub_menus=None
        self._menus_version=0
    @property
    def menus(self):
        """
        Purpose: 
        """
        cacheversion = get_cacheversion()
        version_last=cacheversion[CacheVersion.VerName.AdmMenu].version
        if version_last>self._menus_version or self._menus is None:
            self.update_data()
            self._menus_version=version_last
        return {'menus':self._menus,'sub_menus':self._sub_menus}
    def update_data(self):
        """
        Purpose: 
        """
        qa=AdminMenu.objects.all()
        qb=AdminMenuItem.objects.all()
        if not qa.exists():
            self.init_data()
        self._menus={obj.path:obj for obj in qa}
        for menu in self._menus.values():
            menu.submenu_list=list(menu.submenus.all())
        self._sub_menus={obj.path:obj for obj in qb}
        pass
    def init_data(self):
        """
        Purpose: 
        """
        from django.conf import settings
        if not hasattr(settings,'DEFAULT_ADMMENU'):
            raise Exception("菜单配置异常！")
        
        
        for obj in settings.DEFAULT_ADMMENU:
            menu=AdminMenu()
            menu.name=obj['name']
            menu.sort=obj['sort']
            menu.path=obj['path']
            menu.save()
            # submenus=[]
            for item in obj['submenus']:
                submenu=AdminMenuItem()
                submenu.name=item['name']
                submenu.sort=item['sort']
                submenu.path=item['path']
                submenu.menu=menu
                submenu.save()
            #     submenus.append(submenu)
            # if submenus:
            #     menu.submenus.add(*submenus)

        
        
    # end def
        
cache_admmenu= CacheAdmMenu()

    

