from django.http import HttpRequest
from ..models import EnvVariable

from ..caches import cache_admmenu,cache_envvar
def get_current_path(path,prefix):
    path = path[len(prefix):]
    res = path.split('/')
    if len(res)<2:
        res=[None,None]
        # raise Exception("获取当前路径信息异常！")
    return {'menu_path':res[0],'submenu_path':res[1]}

def menu_processor(request:HttpRequest):
    """
    Purpose: 返回所以menu,当前menu信息
    """
    prefix = cache_envvar.variables[EnvVariable.VarName.AdmPathPrefix]
    menus = cache_admmenu.menus
    current_menu_path = get_current_path(request.path.lower().strip(),prefix.varvalue)
    if current_menu_path['menu_path'] is not None:
        menu_present={'menu_present':menus['menus'][current_menu_path['menu_path']],'submenu_present':menus['sub_menus'][current_menu_path['submenu_path']]}
        menus.update(menu_present)
    menus.update(current_menu_path)
    menus.update({'path_prefix':prefix.varvalue})
    return menus
    
# end def