from django.db import models
from django.db.models import Count, F, Value
# Create your models here.

class CacheVersion(models.Model):
    """Model definition for CacheVersion."""
    class VerName(models.TextChoices):
        """docstring for VarName."""
        AdmMenu='AdmMenu',''
        EnvVar='EnvVar',''
        Category='Category',''
    # TODO: Define fields here
    vername = models.CharField(max_length = 150)
    version = models.IntegerField(default=1)
    @classmethod
    def increase_category_version(cls):
        CacheVersion.objects.filter(vername=cls.VerName.Category).update(version=F('version')+1)
    
    @classmethod
    def increase_envvar_version(cls):
        CacheVersion.objects.filter(vername=cls.VerName.EnvVar).update(version=F('version')+1)
    
    @classmethod
    def increase_admmenu_version(cls):
        CacheVersion.objects.filter(vername=cls.VerName.AdmMenu).update(version=F('version')+1)
        
        pass
    class Meta:
        """Meta definition for CacheVersion."""

        verbose_name = 'CacheVersion'
        verbose_name_plural = 'CacheVersions'

    def __str__(self):
        """Unicode representation of CacheVersion."""
        return f"{self.vername},{self.version}"

    # def save(self):
    #     """Save method for CacheVersion."""
    #     pass

    def get_absolute_url(self):
        """Return absolute url for CacheVersion."""
        return ('')

    # TODO: Define custom methods here


class EnvVariable(models.Model):
    """Model definition for EnvVariable."""

    # TODO: Define fields here
    class VarName(models.TextChoices):
        """docstring for VarName."""
        SiteName='SiteName','站点名称'
        SeoTitle='SeoTitle','Seo标题'
        SeoKewords='SeoKewords','Seo关键字'
        SeoDescription='SeoDescription','Seo描述'
        DomainName='DomainName','域名'
        Custom='Custom','自定义',
        AdmPathPrefix='AdmPathPrefix',''
    class VarType(models.TextChoices):
        """docstring for VarType."""
        Int='Int','整数'
        Str='Str','字符串'
        Float='Float','浮点数'

        
    varname = models.CharField(max_length = 25,choices=VarName.choices,unique=True,default=VarName.Custom)
    vartype = models.CharField(max_length = 25,choices=VarType.choices,default=VarType.Str)
    varvalue = models.CharField(max_length = 255,default='')
    
    class Meta:
        """Meta definition for EnvVariable."""

        verbose_name = 'EnvVariable'
        verbose_name_plural = 'EnvVariables'

    def __str__(self):
        """Unicode representation of EnvVariable."""
        return f"{self.varname},{self.vartype},{self.varvalue}"
