"""
Django settings for app project.

Generated by 'django-admin startproject' using Django 3.2.

For more information on this file, see
https://docs.djangoproject.com/en/3.2/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/3.2/ref/settings/
"""

from pathlib import Path

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/3.2/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'django-insecure-ikdp1pc-=2d4&a#24f59q$b^9w*%$^itnthczn9)!&7t6yp#&x'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = []


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'common',
    'adm',
    # 'category',
    # 'article',
    # 'attachment',
    
]

CACHES = {
    'default': {
        'BACKEND': 'django.core.cache.backends.locmem.LocMemCache',
        'LOCATION': 'unique-snowflake',
        'TIMEOUT': None,
    }
}

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'adm.middleware.cache.CacheMiddleware'
]

ROOT_URLCONF = 'app.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'adm.context_processors.menu.menu_processor'
            ],
        },
    },
]

WSGI_APPLICATION = 'app.wsgi.application'


# Database
# https://docs.djangoproject.com/en/3.2/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': BASE_DIR / 'db.sqlite3',
    }
}
DEFAULT_ENVVARIABLE={
    'SiteName':'站点名称',
    'SeoTitle':'Seo标题',
    'SeoKewords':'Seo关键字',
    'SeoDescription':'Seo描述',
    'DomainName':'域名',
    'AdmPathPrefix':'/adm/',
}
DEFAULT_ADMMENU=[
    {'name':'栏目',
     'sort':1,
     'path':'category',
     'submenus':[
         {
            'name':'所有栏目',
            'sort':1,
            'path':'index',
         },
         {
            'name':'编辑栏目',
            'sort':1,
            'path':'edit',
         }, 
        {
            'name':'文档模型',
            'sort':1,
            'path':'template',
         },    
     ]
     },
    {'name':'文档',
     'sort':1,
     'path':'article',
     'submenus':[
         {
            'name':'所有文档',
            'sort':1,
            'path':'index',
         },
        # {
        #     'name':'待审核',
        #     'sort':1,
        #     'path':'pendingcheck',
        #  },
         {
            'name':'编辑文档',
            'sort':1,
            'path':'edit',
         }, 

     ]
     },
    {'name':'附件',
     'sort':1,
     'path':'attachment',
     'submenus':[
         {
            'name':'所有附件',
            'sort':1,
            'path':'index',
         },
        # {
        #     'name':'待审核',
        #     'sort':1,
        #     'path':'pendingcheck',
        #  },
         {
            'name':'上传附件',
            'sort':1,
            'path':'create',
         }, 
         {
            'name':'修改附件',
            'sort':1,
            'path':'edit',
         }, 

     ]
     },
]
LOGGING = {
    'version': 1,
    'disable_existing_loggers': False,
    'handlers': {
        'console': {
            'class': 'logging.StreamHandler',
        },
    },
    'root': {
        'handlers': ['console'],
        'level': 'WARNING',
    },
    'loggers': {
        'django.db.backends': {
                'level': 'DEBUG',
                'handlers': ['console'],
                'propagate': False,
        },
        'django': {
            'handlers': ['console'],
            'level': 'INFO',
            'propagate': True,
        },
    },
}
# Password validation
# https://docs.djangoproject.com/en/3.2/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/3.2/topics/i18n/

LANGUAGE_CODE = 'zh-hans'
TIME_ZONE = 'Asia/Shanghai'
USE_I18N = True

USE_L10N = True

USE_TZ = False


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/3.2/howto/static-files/

STATIC_URL = '/static/'

# Default primary key field type
# https://docs.djangoproject.com/en/3.2/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'
