from django.db import models
from .category import Category
class Attachment(models.Model):
    """Model definition for Attachment."""
    class ContentType(models.TextChoices):
        """docstring for ContentType."""
        Image='image'
        Audio='audio'
        Vedio='vedio'
        Text='text'
    class MediaType(models.TextChoices):
        """docstring for ClassName."""
        Png='png'
        Jpg='jpg'
        Gif='gif'
    
            
    # TODO: Define fields here
    # summary = models.OneToOneField(Summary, on_delete=models.CASCADE)
    category = models.ForeignKey(Category, on_delete=models.CASCADE,null=False,default=0)
    filename = models.CharField(max_length = 150)
    contenttype = models.CharField(max_length = 150,choices=ContentType.choices)
    media_type = models.CharField(max_length = 150,choices=MediaType.choices)
    path = models.CharField(max_length = 150)
    domain = models.CharField(max_length = 150)
    tags = models.ManyToManyField(Tag)
    keywords = models.CharField(max_length = 150,default='')
    description = models.CharField(max_length = 255,default='')
    
    
    
    class Meta:
        """Meta definition for Attachment."""

        verbose_name = 'Attachment'
        verbose_name_plural = 'Attachments'

    def __str__(self):
        """Unicode representation of Attachment."""
        pass

    def save(self):
        """Save method for Attachment."""
        pass

    def get_absolute_url(self):
        """Return absolute url for Attachment."""
        return ('')

    # TODO: Define custom methods here

