from django.db import models
import datetime
# from .fields import FieldGroup

# class ContentClasses(models.Model):
#     """Model definition for ContentClasses."""

#     # TODO: Define fields here
#     name = models.CharField(max_length = 150)
#     model_class = models.CharField(max_length = 150)
#     modelform_class = models.CharField(max_length = 150)
    
#     class Meta:
#         """Meta definition for ContentClasses."""

#         verbose_name = 'ContentClasses'
#         verbose_name_plural = 'ContentClassess'

#     def __str__(self):
#         """Unicode representation of ContentClasses."""
#         return f"ContentClasses name {self.name},model_class {self.model_class},modelform_class {self.modelform_class}"

#     def get_absolute_url(self):
#         """Return absolute url for ContentClasses."""
#         return ('')

#     # TODO: Define custom methods here


# Create your models here.
class Category(models.Model):
    """Model definition for Category."""

    class Usage(models.TextChoices):
        """docstring for ContentType."""
        Article='article','文章'
        Attachment='attachment','附件'
        Goods='goods','商品'
    
    class Appearance(models.TextChoices):
        """docstring for appearance."""
        Index='index','封面'
        List='list','列表'
        Single='single','单页'
        
    # TODO: Define fields here 
    name = models.CharField(max_length = 150,verbose_name='栏目名称',help_text='')
    template_code = models.CharField(max_length = 150,verbose_name='模板名称')
    appearance = models.CharField(max_length = 150,choices=Appearance.choices,default=Appearance.List,verbose_name='列表页风格')
    parent = models.ForeignKey('self', on_delete=models.CASCADE,blank=True,null=True,verbose_name='上级',help_text='???')
    preid = models.CharField(max_length = 150,default='')
    
    usage = models.CharField(max_length = 150,choices=Usage.choices,default=Usage.Article,verbose_name='栏目用途')
    order_select = models.IntegerField(default=0)
    layer_select = models.IntegerField(default=0)
    
    seo_title = models.CharField(max_length = 150,blank=True)
    seo_keywords = models.CharField(max_length = 255,blank=True)
    seo_description = models.CharField(max_length = 255,blank=True)
    content = models.TextField(blank=True)
    create_at = models.DateTimeField(auto_now=False, auto_now_add=True,null=True)
    update_at = models.DateTimeField(auto_now=True, auto_now_add=False,null=True)
    
    # filed_group = models.ForeignKey(FieldGroup, on_delete=models.CASCADE,blank=True)
    
        
    class Meta:
        """Meta definition for Category."""

        verbose_name = 'Category'
        verbose_name_plural = 'Categorys'

    def __str__(self):
        """Unicode representation of Category."""
        return f"{self.order_select}#Category {self.name},usage {self.get_usage_display()}"


    def get_absolute_url(self):
        """Return absolute url for Category."""
        return ('')

    # TODO: Define custom methods here
