from django.db import models

class FieldGroup(models.Model):
    """Model definition for FieldGroup."""
    
    # TODO: Define fields here
    name = models.CharField(max_length = 150)
    description = models.CharField(max_length = 150)
    class Meta:
        """Meta definition for FieldGroup."""

        verbose_name = 'FieldGroup'
        verbose_name_plural = 'FieldGroups'

    def __str__(self):
        """Unicode representation of FieldGroup."""
        pass


class Field(models.Model):
    """Model definition for Field."""
    class FieldType(models.TextChoices ):
        Str='Str','字符串'
        Text='Text','文本'
        html='html','超文本'
        Int='Int','整数'
        Decimal='Decimal','固定精度小数'
        File='File','文件'
        images='Images','图片组'

    
        
    # TODO: Define fields here
    group = models.ForeignKey(FieldGroup, on_delete=models.CASCADE)
    fieldName = models.CharField(max_length = 150)
    fieldType = models.CharField(max_length = 150,choices=FieldType.choices)
    verbose_name = models.CharField(max_length = 150)
    
    class Meta:
        """Meta definition for Field."""

        verbose_name = 'Field'
        verbose_name_plural = 'Fields'

    def __str__(self):
        """Unicode representation of Field."""
        pass
