from django.db import models
from django.utils import timezone
# Create your models here.
class User(models.Model):
    """Model definition for User."""

    # TODO: Define fields here
    username = models.CharField(max_length = 150,null=False)
    email = models.CharField(max_length = 150)
    password = models.CharField(max_length = 150,null=False)
    status = models.IntegerField(default=0,null=False)
    create_at = models.DateTimeField()
    update_at = models.DateTimeField()
    class Meta:
        """Meta definition for User."""

        verbose_name = 'User'
        verbose_name_plural = 'Users'

    def __str__(self):
        """Unicode representation of User."""
        pass

    # def save(self):
    #     """Save method for User."""
    #     pass

    def get_absolute_url(self):
        """Return absolute url for User."""
        return ('')

    # TODO: Define custom methods here
class Category(models.Model):
    """Model definition for Category."""

    # TODO: Define fields here
    name = models.CharField(max_length = 150,verbose_name='栏目名称',help_text='')
    parent = models.ForeignKey('self', on_delete=models.CASCADE,blank=True,null=True,verbose_name='上级',help_text='???')
    preid = models.CharField(max_length = 150,default='')
    content = models.TextField(blank=True)
    create_at = models.DateTimeField(auto_now=False, auto_now_add=True,null=True)
    update_at = models.DateTimeField(auto_now=True, auto_now_add=False,null=True)
    class Meta:
        """Meta definition for Category."""

        verbose_name = 'Category'
        verbose_name_plural = 'Categorys'

    def __str__(self):
        """Unicode representation of Category."""
        pass
class Tag(models.Model):
    """Model definition for Tag."""

    # TODO: Define fields here
    name = models.CharField(max_length = 150)
    class Meta:
        """Meta definition for Tag."""

        verbose_name = 'Tag'
        verbose_name_plural = 'Tags'

    def __str__(self):
        """Unicode representation of Tag."""
        pass

class Article(models.Model):
    """Model definition for Article."""

    # TODO: Define fields here
    title = models.CharField(max_length = 150,default='')
    category = models.ForeignKey(Category, on_delete=models.CASCADE,null=True)
    user = models.ForeignKey(User, on_delete=models.CASCADE,null=True)
    tags = models.ManyToManyField(Tag)
    create_at = models.DateTimeField(auto_now=False, auto_now_add=True,null=True)
    update_at = models.DateTimeField(auto_now=True, auto_now_add=False,null=True)
    class Meta:
        """Meta definition for Article."""

        verbose_name = 'Article'
        verbose_name_plural = 'Articles'

    def __str__(self):
        """Unicode representation of Article."""
        pass

class ArticleContent(models.Model):
    """Model definition for Content."""

    # TODO: Define fields here
    summary = models.OneToOneField(Article, on_delete=models.CASCADE,related_name='content')
    content = models.TextField()
    
    class Meta:
        """Meta definition for Content."""

        verbose_name = 'Content'
        verbose_name_plural = 'Contents'

    def __str__(self):
        """Unicode representation of Content."""
        return f"文档内容#{self.summary.id}#{self.summary.title}"